=== debian/changelog ===
lemonade (9.2.0-0ubuntu1) resolute; urgency=medium

  * New upstream version
  * d/watch, d/copyright:
    Drop dfsg prefix and repack, upstream dropped the non-free components
  * Refresh patches and drop upstream ones
  * Drop python3, it was split into a separate repo not part of release

 -- Mario Limonciello <superm1@debian.org>  Wed, 28 Jan 2026 13:20:53 -0600

lemonade (9.1.4+dfsg-0ubuntu1) resolute; urgency=medium

  * New upstream version
  * Add manpages for binaries
  * Add gbp.conf
  * d/rules: build using ninja
  * d/patches: Link with system libraries instead of embedded copies
  * d/patches: Add a patch for using POXIS getaddrinfo instead
  * d/patches: Prevent using Google fonts from the web
  * d/control:
    - Add python3-openai to b-d
    - Add python3-fastapi to b-d
    - Add cmake to b-d
    - Add libcli11-dev to b-d 
    - Add libcpp-httplib-dev to b-d
    - Add libcurl4-openssl-dev to b-d
    - Add nlohmann-json3-dev to b-d
    - Add libssl-dev to b-d
    - Add libzstd-dev to b-d
    - Add ninja-build to b-d

 -- Mario Limonciello <superm1@debian.org>  Fri, 23 Jan 2026 12:06:12 -0600

lemonade (9.0.2+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1120707)

 -- Mario Limonciello <superm1@debian.org>  Fri, 14 Nov 2025 22:47:17 -0600
