=== debian/control ===
Source: lemonade
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mario Limonciello <superm1@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libcli11-dev,
 libcpp-httplib-dev (>> 0.26),
 libcurl4-openssl-dev,
 nlohmann-json3-dev,
 libssl-dev,
 libzstd-dev,
 ninja-build,
Testsuite: autopkgtest-pkg-python
Standards-Version: 4.7.2
Homepage: https://lemonade-server.ai/
Vcs-Browser: https://salsa.debian.org/debian/lemonade
Vcs-Git: https://salsa.debian.org/debian/lemonade.git

Package: lemonade-server
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libcurl4
Description: Local LLM serving with GPU and NPU acceleration server
 Lemonade helps users run local LLMs with the highest performance by
 configuring state-of-the-art inference engines for their NPUs and GPUs.
 .
 Lemonade works with model providers such as huggingface.
 This package provides the server.
