=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	mkdir -p cpp_build
	cd cpp_build && cmake ../src/cpp -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -G Ninja
	dh_auto_configure

override_dh_auto_build:
	ninja -C cpp_build
	dh_auto_build

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp ninja -C cpp_build install
	dh_auto_install

override_dh_clean:
	rm -rf cpp_build
	dh_clean
