=== debian/changelog ===
lemonade (9.3.0-0ubuntu1) resolute; urgency=medium

  * Backport to resolute.

 -- Mario Limonciello <superm1@debian.org>  Fri, 06 Feb 2026 02:35:42 +0000

lemonade (9.3.0-1) experimental; urgency=medium

  * New upstream version.
  * d/control: Add build dependencies for web-app
  * d/control: bump standards version to 4.7.3
  * d/control: Add new fonts-katex dependency for web app
  * d/control: Add lemonade-desktop package
  * d/lemonade-server.install: Add web-app
  * d/postinst: Create user for lemonade server
  * d/patches: refresh
  * d/webpack: Add configuration to run webpack at build
  * d/rules: Build web-app manually without pulling anything from the web
  * d/patches: backport a patch to put web app application in correct path
  * d/patches: backport some patches to fix about dialog

 -- Mario Limonciello <superm1@debian.org>  Thu, 05 Feb 2026 19:22:57 -0600

lemonade (9.2.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1120707)
    - Upload to experimental pending libcpp-httplib-dev moving to unstable

 -- Mario Limonciello <superm1@debian.org>  Fri, 30 Jan 2026 12:42:39 -0600
