## lemonade 9.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
 endif()
 
-project(lemon_cpp VERSION 9.3.0)
+project(lemon_cpp VERSION 9.3.2)
 
 # Enable Objective-C++ for macOS Metal support
 if(APPLE)
