=== debian/changelog ===
lemonade (9.3.2-0ubuntu1) resolute; urgency=medium

  * Backport to resolute.

 -- Mario Limonciello <superm1@debian.org>  Thu, 12 Feb 2026 23:12:31 -0600

lemonade (9.3.2-1) experimental; urgency=medium

  [ Tim Flink ]
  * d/control: add unzip, libatomic1 as runtime deps for lemonade-server

  [ Mario Limonciello (AMD) ]
  * refresh patches
  * releasing package lemonade version 9.3.2-1

 -- Mario Limonciello <superm1@debian.org>  Thu, 12 Feb 2026 23:10:39 -0600

lemonade (9.3.1-1) experimental; urgency=medium

  * New upstream version.
  * refresh patches

 -- Mario Limonciello <superm1@debian.org>  Fri, 06 Feb 2026 22:59:57 -0600
